<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__flash" kind="group">
    <compoundname>group_flash</compoundname>
    <title>Flash        (Flash System Routine)</title>
    <innergroup refid="group__group__flash__macros">Macros</innergroup>
    <innergroup refid="group__group__flash__functions">Functions</innergroup>
    <innergroup refid="group__group__flash__enumerated__types">Enumerated Types</innergroup>
    <briefdescription>
<para>Internal flash memory programming. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_flash.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>Flash memory in PSoC devices provides non-volatile storage for user firmware, user configuration data, and bulk data storage.</para><para>Flash operations are implemented as system calls. System calls are executed out of SROM in the privileged mode of operation. Users have no access to read or modify the SROM code. The driver API requests the system call by acquiring the Inter-processor communication (IPC) and writing the SROM function opcode and parameters to its input registers. As a result, an NMI interrupt is invoked and the requested SROM function is executed. The operation status is returned to the driver context and a release interrupt is triggered.</para><para>Writing to flash can take up to 20 milliseconds. During this time, the device should not be reset (including XRES pin, software reset, and watchdog) or unexpected changes may be made to portions of the flash. Also, the low-voltage detect circuits should be configured to generate an interrupt instead of a reset.</para><para>A Read while Write violation occurs when a flash Read operation is initiated in the same or neighboring (neighboring restriction is applicable just for the CY8C6xx6, CY8C6xx7 devices) flash sector where the flash Write, Erase, or Program operation is working. This violation may cause a HardFault exception. To avoid the Read while Write violation, carefully split the Read and Write operation on flash sectors which are not neighboring, considering both cores in the multi-processor device. If the flash is divided into four equal sectors, you may edit the linker script to place the code into neighboring sectors. For example, use sectors number 0 and 1 for code and sectors 2 and 3 for data storage.</para>
<para><heading level="1">Configuration Considerations</heading></para>

<para><bold>Introduction:</bold></para>
<para>The PSoC 6 MCU user-programmable Flash consists of:<itemizedlist>
<listitem><para>Application flash memory (from 2 to 8 sectors) - 128KB/256KB each.</para></listitem><listitem><para>EE emulation flash memory - 32KB.</para></listitem></itemizedlist>
</para><para>Write operation may be done as Blocking or Partially Blocking, defined as follows:</para>

<para><bold>Blocking:</bold></para>
<para>In this case, the entire Flash block is not available for the duration of the Write (<sim />16ms). Therefore, no Flash accesses (from any Bus Master) can occur during that time. CPU execution can be performed from SRAM. All pre-fetching must be disabled. Code execution from Flash is blocked for the Flash Write duration for both cores.</para>

<para><bold>Constraints for Blocking Flash operations:</bold></para>
<para><orderedlist>
<listitem><para>During write to flash, the device should not be reset (including XRES pin, software reset, and watchdog), or unexpected changes may be made to portions of the flash.</para></listitem><listitem><para>The low-voltage detect circuits should be configured to generate an interrupt instead of a reset.</para></listitem><listitem><para>Flash rite operation is allowed only in one of the following CM4 states:<orderedlist>
<listitem><para>CM4 is Active and initialized:<linebreak />
 call <ref kindref="member" refid="group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557">Cy_SysEnableCM4(CY_CORTEX_M4_APPL_ADDR)</ref>. <bold>Note:</bold> If desired user may put CM4 core in Deep Sleep any time after calling <ref kindref="member" refid="group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557">Cy_SysEnableCM4()</ref>.</para></listitem><listitem><para>CM4 is Off and disabled:<linebreak />
 call <ref kindref="member" refid="group__group__system__config__cm4__functions_1ga4df7e46b2841b62a00ab856e5a6f098f">Cy_SysDisableCM4()</ref>. <bold>Note:</bold> In this state Debug mode is not supported.</para></listitem></orderedlist>
</para></listitem><listitem><para>Flash Write cannot be performed in Ultra Low Power (core voltage 0.9V) mode.</para></listitem><listitem><para>Interrupts must be enabled on both active cores. Do not enter a critical section during flash operation.</para></listitem><listitem><para>For the CY8C6xx6, CY8C6xx7 devices user must guarantee that system pipe interrupts (IPC interrupts 3 and 4) have the highest priority, or at least that pipe interrupts are not interrupted or in a pending state for more than 700 <micro />s.</para></listitem><listitem><para>User must guarantee that during flash write operation no flash read operations are performed by bus masters other than CM0+ and CM4 (DMA and Crypto).</para></listitem><listitem><para>If you do not use the default startup, perform the following steps before any flash write/erase operations: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />1.<sp />Allocate<sp />and<sp />initialize<sp />IPC<sp />semaphores<sp />for<sp />the<sp />system<sp />operations<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint32_t<sp />ipcSemaArray[<ref kindref="member" refid="group__group__system__config__user__settings__macro_1gaba78bac52ffcbd69ab531467fa3caa6d">CY_IPC_SEMA_COUNT</ref><sp />/<sp /><ref kindref="member" refid="group__group__ipc__sema__macros_1ga7c011c5126248439921e442aab3c6b23">CY_IPC_SEMA_PER_WORD</ref>];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1ga1cbc3b147c650c8716de10a1ee8423bd">Cy_IPC_Sema_Init</ref>(CY_IPC_CHAN_SEMA,<sp /><ref kindref="member" refid="group__group__system__config__user__settings__macro_1gaba78bac52ffcbd69ab531467fa3caa6d">CY_IPC_SEMA_COUNT</ref>,<sp />ipcSemaArray);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />2.<sp />Create<sp />an<sp />array<sp />of<sp />endpoint<sp />structures<sp />and<sp />configure<sp />an<sp />IPC<sp />pipe<sp />infrastructure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__t">cy_stc_ipc_pipe_ep_t</ref><sp />ipcPipeEpArray[<ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga26b976c68c4fc4e45bc7f400e97c8495">CY_IPC_MAX_ENDPOINTS</ref>];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga7a1c8f1e92e74f27856ef2b7ac09c640">Cy_IPC_Pipe_Config</ref>(ipcPipeEpArray);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />3.<sp />Create<sp />an<sp />array<sp />of<sp />client<sp />callbacks<sp />and<sp />initialize<sp />a<sp />system<sp />pipe<sp />by<sp />a<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_ipc_pipe_callback_ptr_t<sp />sysIpcPipeCbArray[CY_SYS_CYPIPE_CLIENT_CNT];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ipc__pipe__config__t">cy_stc_ipc_pipe_config_t</ref><sp />systemIpcPipeConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ep0ConfigData<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierNumber<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_IPC_INTR_CYPIPE_EP0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierPriority<sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_INTR_CYPIPE_PRIOR_EP0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierMuxNumber<sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_INTR_CYPIPE_MUX_EP0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_IPC_EP_CYPIPE_CM0_ADDR,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_CYPIPE_CONFIG_EP0</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />},</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ep1ConfigData<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierNumber<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_IPC_INTR_CYPIPE_EP1,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierPriority<sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_INTR_CYPIPE_PRIOR_EP1,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierMuxNumber<sp />*/</highlight><highlight class="normal"><sp /><sp />0u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_IPC_EP_CYPIPE_CM4_ADDR,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_CYPIPE_CONFIG_EP1</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />},</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.endpointClientsCount<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_CYPIPE_CLIENT_CNT,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.endpointsCallbacksArray<sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />sysIpcPipeCbArray,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.systemPipeIsrHandler<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />&amp;SysIpcPipeIsr</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1gafb7fa479327e6d7c282c262bc1dc6c8c">Cy_IPC_Pipe_Init</ref>(&amp;systemIpcPipeConfig);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />4.<sp />And<sp />finally<sp />initialize<sp />the<sp />flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__flash__functions_1gaf1b44a029169a1baa08e211bff714a19">Cy_Flash_Init</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Ensure<sp />to<sp />run<sp />these<sp />steps<sp />on<sp />all<sp />the<sp />MCU<sp />cores<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para></listitem></orderedlist>
</para>

<para><bold>Partially Blocking:</bold></para>
<para>This method has a much shorter time window during which Flash accesses are not allowed. Application code execution from Flash is blocked for only a part of Flash Write duration, for both cores. Blocking duration depends upon the API sequence used.</para><para>For API sequence <ref kindref="member" refid="group__group__flash__functions_1ga36c8da8da155cd73eaf3359f3f81af02">Cy_Flash_StartEraseRow()</ref> + <ref kindref="member" refid="group__group__flash__functions_1gafc57348bb2e6922a65826bccad961fed">Cy_Flash_StartProgram()</ref> there are four block-out regions during which Read is blocked. See <bold>Figure 1</bold>.</para><para> <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;caption&gt;Table 1 - Block-out periods (timing values are valid just for the CY8C6xx6, CY8C6xx7 devices) &lt;/caption&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Block-out &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Phase &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Duration  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The beginning of the Erase operation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;2ms + 9500 SlowClk cycles  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;B &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The end of the Erase operation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0.13ms + 1000 SlowClk cycles  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;C &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The beginning of the Program operation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0.8ms + 6000 SlowClk cycles  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;D &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The end of the Program operation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;0.13ms + 1000 SlowClk cycles  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para><para>This allows both cores to execute for about 80% of Flash Write operation - see <bold>Figure 1</bold>. This capability is important for communication protocols that rely on fast response.</para><para><image name="flash-rww-diagram.png" type="html">Figure 1 - Blocking Intervals in Flash Write operation</image>
 For the <ref kindref="member" refid="group__group__flash__functions_1gafed287628c010c2258f73c5777b52292">Cy_Flash_StartWrite()</ref> function, the block-out period is different for the two cores. The core that initiates <ref kindref="member" refid="group__group__flash__functions_1gafed287628c010c2258f73c5777b52292">Cy_Flash_StartWrite()</ref> is blocked for two periods:<itemizedlist>
<listitem><para>From start of Erase operation (start of A on Figure 1) till the start of Program operation (end of C on Figure 1).</para></listitem><listitem><para>During D period on <bold>Figure 1</bold>.</para></listitem></itemizedlist>
</para><para>The core that performs read/execute is blocked identically to the previous scenario - see <bold>Figure 1</bold>.</para><para>This allows the core that initiates <ref kindref="member" refid="group__group__flash__functions_1gafed287628c010c2258f73c5777b52292">Cy_Flash_StartWrite()</ref> to execute for about 20% of Flash Write operation. The other core executes for about 80% of Flash Write operation.</para><para>Some constraints must be planned for in the Partially Blocking mode which are described in detail below.</para>

<para><bold>Constraints for Partially Blocking Flash operations:</bold></para>
<para><orderedlist>
<listitem><para>During write to flash, the device should not be reset (including XRES pin, software reset, and watchdog) or unexpected changes may be made to portions of the flash.</para></listitem><listitem><para>The low-voltage detect circuits should be configured to generate an interrupt instead of a reset.</para></listitem><listitem><para>During write to flash, application code should not change the clock settings. Use <ref kindref="member" refid="group__group__flash__functions_1ga436020eae198750c56b93dbabdf6dc6d">Cy_Flash_IsOperationComplete()</ref> to ensure flash write operation is finished.</para></listitem><listitem><para>During write to flash, application code should not start the clock measurements (should not call <ref kindref="member" refid="group__group__sysclk__calclk__funcs_1ga0a87e123411d5711344780ddfa492f37">Cy_SysClk_StartClkMeasurementCounters()</ref>).</para></listitem><listitem><para>Flash write operation is allowed only in one of the following CM4 states:<orderedlist>
<listitem><para>CM4 is Active and initialized:<linebreak />
 call <ref kindref="member" refid="group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557">Cy_SysEnableCM4(CY_CORTEX_M4_APPL_ADDR)</ref>. <bold>Note:</bold> If desired user may put CM4 core in Deep Sleep any time after calling <ref kindref="member" refid="group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557">Cy_SysEnableCM4()</ref>.</para></listitem><listitem><para>CM4 is Off and disabled:<linebreak />
 call <ref kindref="member" refid="group__group__system__config__cm4__functions_1ga4df7e46b2841b62a00ab856e5a6f098f">Cy_SysDisableCM4()</ref>. <bold>Note:</bold> In this state Debug mode is not supported.</para></listitem></orderedlist>
</para></listitem><listitem><para>Use the following rules for split by sectors. (In this context, read means read of any bus master: CM0+, CM4, DMA, Crypto, etc.)<orderedlist>
<listitem><para>Do not write to and read/execute from the same flash sector at the same time. This is true for all sectors.</para></listitem><listitem><para>Writing rules in application flash (this restriction is applicable just for CY8C6xx6, CY8C6xx7 devices):<orderedlist>
<listitem><para>Any bus master can read/execute from UFLASH S0 and/or S1, during flash write to UFLASH S2 or S3.</para></listitem><listitem><para>Any bus master can read/execute from UFLASH S2 and/or S3, during flash write to UFLASH S0 or S1.</para></listitem></orderedlist>
</para><para><bold>Suggestion:</bold> in case of bootloading, it is recommended to place code for CM4 in either S0 or S1. CM0+ code resides in S0. Write data to S2 and S3 sections.</para></listitem></orderedlist>
</para></listitem><listitem><para>Flash Write cannot be performed in Ultra Low Power mode (core voltage 0.9V).</para></listitem><listitem><para>Interrupts must be enabled on both active cores. Do not enter a critical section during flash operation.</para></listitem><listitem><para>For the CY8C6xx6, CY8C6xx7 devices user must guarantee that system pipe interrupts (IPC interrupts 3 and 4) have the highest priority, or at least that pipe interrupts are not interrupted or in a pending state for more than 700 <micro />s.</para></listitem><listitem><para>If you do not use the default startup, perform the following steps before any flash write/erase operations: <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />1.<sp />Allocate<sp />and<sp />initialize<sp />IPC<sp />semaphores<sp />for<sp />the<sp />system<sp />operations<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp />uint32_t<sp />ipcSemaArray[<ref kindref="member" refid="group__group__system__config__user__settings__macro_1gaba78bac52ffcbd69ab531467fa3caa6d">CY_IPC_SEMA_COUNT</ref><sp />/<sp /><ref kindref="member" refid="group__group__ipc__sema__macros_1ga7c011c5126248439921e442aab3c6b23">CY_IPC_SEMA_PER_WORD</ref>];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__ipc__sema__functions_1ga1cbc3b147c650c8716de10a1ee8423bd">Cy_IPC_Sema_Init</ref>(CY_IPC_CHAN_SEMA,<sp /><ref kindref="member" refid="group__group__system__config__user__settings__macro_1gaba78bac52ffcbd69ab531467fa3caa6d">CY_IPC_SEMA_COUNT</ref>,<sp />ipcSemaArray);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />2.<sp />Create<sp />an<sp />array<sp />of<sp />endpoint<sp />structures<sp />and<sp />configure<sp />an<sp />IPC<sp />pipe<sp />infrastructure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ipc__pipe__ep__t">cy_stc_ipc_pipe_ep_t</ref><sp />ipcPipeEpArray[<ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga26b976c68c4fc4e45bc7f400e97c8495">CY_IPC_MAX_ENDPOINTS</ref>];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1ga7a1c8f1e92e74f27856ef2b7ac09c640">Cy_IPC_Pipe_Config</ref>(ipcPipeEpArray);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />3.<sp />Create<sp />an<sp />array<sp />of<sp />client<sp />callbacks<sp />and<sp />initialize<sp />a<sp />system<sp />pipe<sp />by<sp />a<sp />configuration<sp />structure<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_ipc_pipe_callback_ptr_t<sp />sysIpcPipeCbArray[CY_SYS_CYPIPE_CLIENT_CNT];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__ipc__pipe__config__t">cy_stc_ipc_pipe_config_t</ref><sp />systemIpcPipeConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ep0ConfigData<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierNumber<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_IPC_INTR_CYPIPE_EP0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierPriority<sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_INTR_CYPIPE_PRIOR_EP0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierMuxNumber<sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_INTR_CYPIPE_MUX_EP0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_IPC_EP_CYPIPE_CM0_ADDR,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_CYPIPE_CONFIG_EP0</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />},</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ep1ConfigData<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierNumber<sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_IPC_INTR_CYPIPE_EP1,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierPriority<sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_INTR_CYPIPE_PRIOR_EP1,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.ipcNotifierMuxNumber<sp />*/</highlight><highlight class="normal"><sp /><sp />0u,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epAddress<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_IPC_EP_CYPIPE_CM4_ADDR,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.epConfig<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_CYPIPE_CONFIG_EP1</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />},</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.endpointClientsCount<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />CY_SYS_CYPIPE_CLIENT_CNT,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.endpointsCallbacksArray<sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />sysIpcPipeCbArray,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.systemPipeIsrHandler<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp />&amp;SysIpcPipeIsr</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__ipc__pipe__functions_1gafb7fa479327e6d7c282c262bc1dc6c8c">Cy_IPC_Pipe_Init</ref>(&amp;systemIpcPipeConfig);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />4.<sp />And<sp />finally<sp />initialize<sp />the<sp />flash<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__flash__functions_1gaf1b44a029169a1baa08e211bff714a19">Cy_Flash_Init</ref>();</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Ensure<sp />to<sp />run<sp />these<sp />steps<sp />on<sp />all<sp />the<sp />MCU<sp />cores<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para></listitem></orderedlist>
</para>

<para><bold>EEPROM section use:</bold></para>
<para>If you plan to use "cy_em_eeprom" section for different purposes for both of device cores or use <bold>Em_EEPROM Middleware</bold> together with flash driver write operations you must modify the linker scripts.<linebreak />
 For more information, refer to the <bold>Middleware/Cypress Em_EEPROM Middleware Library</bold> section of the PDL documentation.</para>


<para><heading level="1">More Information</heading></para>
<para>See the technical reference manual (TRM) for more information about the Flash architecture.</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Casting to different object pointer type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The cast of the uint32_t pointer to pipe message structure pointer is used to get transmitted data via the &lt;a href="group__group__ipc.html#"&gt;IPC (Inter Process Communication)&lt;/a&gt; channel. We cast only one pointer, so there is no way to avoid this cast. &lt;/p&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.40 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated Cy_Flash_OperationStatus() to access protected registers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added PSoC 64 device support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.30.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improved documentation. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.30.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated documentation to limit devices with the restrictions. Improved calculation of the CY_FLASH_DELAY_CORRECTIVE macro. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.30.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated documentation to limit devices with the neighboring restriction. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.30.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Used the CY_RAMFUNC_BEGIN and CY_RAMFUNC_END macros that allocate the function in RAM instead of using the CY_SECTION(".cy_ramfunc") macros. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Removed the code duplication.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;3.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Moved ipcWaitMessageStc structure to the RAM section called ".cy_sharedmem". &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support Secure Boot devices.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Renamed Function Cy_Flash_StartErase() to &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga36c8da8da155cd73eaf3359f3f81af02"&gt;Cy_Flash_StartEraseRow()&lt;/a&gt;. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The driver improvements based on the usability feedback.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added new API functions &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga23e040ae57d5c4f717b1918eda77ecc5"&gt;Cy_Flash_EraseSector&lt;/a&gt;, &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga42900a5b1b692efc825083c262cc2d7d"&gt;Cy_Flash_StartEraseSector&lt;/a&gt;, &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1gadb9cf4bec4ce4202604823cf0feb70ac"&gt;Cy_Flash_EraseSubsector&lt;/a&gt;, &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga732a0c229dd1acee3b36f1bba0045976"&gt;Cy_Flash_StartEraseSubsector&lt;/a&gt;  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The driver improvements based on the usability feedback.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;3.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added new API function &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga3daa482b7696dcb6e06f0776e0ca725a"&gt;Cy_Flash_InitExt&lt;/a&gt; &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The driver improvements based on the usability feedback  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.11 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated driver functionality to correctly use the SysClk measurement counters while partially blocking flash operations &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added arbiter mechanism for correct usage of the SysClk measurement counters  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated Cy_Flash_SendCmd() code to support single core devices. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support new devices  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;3.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;New function - &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga5218274c43e64791cf28f902d15a355a"&gt;Cy_Flash_ProgramRow()&lt;/a&gt;;&lt;br /&gt; Updated &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga29ac711091186d8a7790be298fb6148b"&gt;Cy_Flash_RowChecksum()&lt;/a&gt;: changed input parameter to take the &lt;b&gt;row address&lt;/b&gt; (rowAddr) instead of the &lt;b&gt;row number&lt;/b&gt; (rowNum);&lt;br /&gt; Renamed macro for disabling RWW support in driver to &lt;b&gt;CY_FLASH_RWW_DRV_SUPPORT_DISABLED&lt;/b&gt;.&lt;br /&gt; Updated &lt;a href="#group__group__flash_1group_flash_configuration"&gt;Configuration Considerations&lt;/a&gt; documentation section with flash usage constraints. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improvements made based on usability feedback to use a common interface  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added non-blocking erase function - Cy_Flash_StartErase(). Removed the clear cache function call. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The clear cache operation is removed from the blocking Write/Erase function because in this case it is performed by the hardware. Otherwise it is documented that it is the user's responsibility to clear the cache after executing the non-blocking Write/Erase flash operation.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added new &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga436020eae198750c56b93dbabdf6dc6d"&gt;Cy_Flash_IsOperationComplete()&lt;/a&gt; function to check completeness. Obsoleted Cy_Flash_IsWriteComplete(), Cy_Flash_IsProgramComplete(), and Cy_Flash_IsEraseComplete() functions.&lt;br /&gt; Added &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1ga607931427f2d4a2147c7c97ce96577e0"&gt;Cy_Flash_GetExternalStatus()&lt;/a&gt; function to get unparsed status where flash driver will be used in security applications with other modules as SecureImage.&lt;br /&gt; Added &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1gaf1b44a029169a1baa08e211bff714a19"&gt;Cy_Flash_Init()&lt;/a&gt; function to initialize all needed prerequisites for Erase/Write operations. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated driver design to improve user experience.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated driver implementation to remove MISRA rules deviations. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver implementation quality improvement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>